/*
 * test8.cpp
 *
 *  Created on: 03.05.2009
 *      Author: Лёха
 */


#include "../tracer/Vector.h"
#include "../tracer/Tracer.h"
#include "../tracer/Render.h"
#include "../tracer/Geometry.h"
#include "../texture/map.h"
#include "../texture/planemap.h"
#include "../texture/brick.h"

QImage * test8() {
	Vector t1, t2, t3, t4;
	Scene = new Environment();

	//освещение
	t1 = Vector(10, 5, -10);
	PointLight * Light1 = new PointLight(t1, 17);
	Scene->Add(Light1);

	//основа дома
	t1 = Vector(0, 1, 4);
	t2 = Vector ( 4.5, 0, 3 );
	t3 = Vector ( -4.5, 0, 3 );
	t4 = Vector ( 0, -3, 0 );
	Medium med = { 1.5, 0 };
	Box * b = new Box(t1, t2, t3, t4);
	b->DefMaterial.Ka = 0.2;
	b->DefMaterial.Kd = 0.5;
	b->DefMaterial.Ks = 0.6;
	b->DefMaterial.Kr = 0.0;
	b->DefMaterial.Kt = 0.0;
	b->DefMaterial.p = 30;
	b->DefMaterial.Color = Vector(0.59608, 0.298, 0);
	b->DefMaterial.Med = med;
	t1 = Vector(0.5,0.2,0.5);
	t2 = Vector(0.05);
	t4 = Vector(0.5);
	t3 = Vector(0.9, 0.4, 0.3); //Firebrick
	b->Add(new Brick(t1, t2, t3, t4));
	Scene->Add(b);

	//земля
	t1 = Vector(0, 1, 0);
	Plane *p = new Plane(t1, 1);
	p->DefMaterial = b->DefMaterial;
	p->DefMaterial.Ka = 0.4;
	p->DefMaterial.Ks = 0.5;
	p->DefMaterial.Kd = 0.4;
	p->DefMaterial.Kr = 0;
	p->DefMaterial.Color = Vector(0, 1, 0);
	QImage * img_ = new QImage("c:/diplom/src/voxel/debug/Grass.bmp");
	ColorMap * cmap = new ColorMap ( img_ );
	cmap -> Scale = 100;
	t1 = Vector(1);
	t2 = Vector(1, 0.5, 0);
	p -> Mapping = new PlaneMap(t1, t2);
	p -> Add ( cmap );
	Scene->Add(p);

	//шар
	t1 = Vector(-1.5, 0.9, 5);
	Sphere *s1 = new Sphere(t1, 1);
	s1->DefMaterial.Ka = 0.5;
	s1->DefMaterial.Kd = 0.5;
	s1->DefMaterial.Ks = 0.6;
	s1->DefMaterial.Kr = 0.0;
	s1->DefMaterial.Kt = 0.5;
	s1->DefMaterial.p = 30;
	s1->DefMaterial.Color = Vector(1, 1, 0);
	Scene->Add(s1);

	//зеркало
	t1 = Vector(5.5, 0.001, 4);
	t2 = Vector ( 1, 0, 0.6 );
	t3 = Vector ( -0.1, 2, 0 );
	t4 = Vector ( 0, 0, 3 );
	Box * r = new Box(t1, t2, t3, t4);
	r->DefMaterial.Ka = 0.2;
	r->DefMaterial.Kd = 0.5;
	r->DefMaterial.Ks = 0.6;
	r->DefMaterial.Kr = 1; //зеркало
	r->DefMaterial.Kt = 0.0;
	r->DefMaterial.p = 30;
	r->DefMaterial.Color = Vector(1, 0, 0);
	Scene->Add(r);

	//шар2 (в зеркале)
	t1 = Vector(4.5, 0.9, 5.5);
	Sphere *s2 = new Sphere(t1, 0.5);
	s2->DefMaterial = s1->DefMaterial;
	s2->DefMaterial.Color = Vector(1, 0, 0);
	Scene->Add(s2);

	//шар3 с текстурой из файла
	t1 = Vector(0.5, -0.8, 2);
	Sphere *s3 = new Sphere(t1, 0.2);
	s3->DefMaterial = s1->DefMaterial;
	s3->DefMaterial.Color = Vector(1, 0.5, 0);
	Scene->Add(s3);

	//стенка слева
	t1 = Vector(-5.5, -1, 4);
	t2 = Vector ( 0.1, 0, 0 );
	t3 = Vector ( 0, 2, 0 );
	t4 = Vector ( 0, 0, 3 );
	Box * b1 = new Box(t1, t2, t3, t4);
	b1->DefMaterial = r->DefMaterial;
	b1->DefMaterial.Kr = 0;
	b1->DefMaterial.Ka = 0.4;
	b1->DefMaterial.Kd = 0.4;
	b1->DefMaterial.Color = Vector(0.3,0.3,0.3);
	img_ = new QImage("c:/diplom/src/voxel/debug/LIMESTO1.JPG");
	cmap = new ColorMap ( img_ );
	cmap -> Scale = 200;
	t1 = Vector(1);
	t2 = Vector(1, 0.5, 0);
	b1 -> Mapping = new PlaneMap(t1, t2);
	b1 -> Add ( cmap );
	Scene->Add(b1);

	Background = Vector(0.196078, 0.6, 0.8 ); //sky blue
	t1 = Vector(0);
	t2 = Vector(0, 0, 1);
	t3 = Vector(0, 1, 0);
	SetCamera(t1, t2, t3);
	return RenderScene(1.5, 1.0, 900, 600);
}

