/*
 * map.cpp
 *
 *  Created on: 20.02.2009
 *      Author: Лёха
 */

#include "../tracer/Tracer.h"
#include "map.h"
#include <QColor>

void ColorMap :: Apply(Vector& p, SurfaceData& t) {
	double x = Mod(Offs.x + Scale.x * t.MapCoord.x, Img->width());
	double y = Mod(Offs.y + Scale.y * t.MapCoord.y, Img->height());
	int ix = (int) x;
	int iy = (int) y;
	int jx = ix + 1;
	int jy = iy + 1;
	x -= ix;
	y -= iy;
	if(jx >= Img->width()) jx = 0; //wrap around
	if(jy >= Img->height()) jy = 0;
	QColor c00 = Img->pixel(ix, iy);
	QColor c01 = Img->pixel(ix, jy);
	QColor c10 = Img->pixel(jx, iy);
	QColor c11 = Img->pixel(jx, jy);
	t.Color.x = ((1-x)*(1-y) * c00.red() + (1-x)*y*c01.red() +
				x*(1-y)*c10.red() + x*y*c11.red()) / 255;
	t.Color.y = ((1-x)*(1-y) * c00.green() + (1-x)*y*c01.green() +
					x*(1-y)*c10.green() + x*y*c11.green()) / 255;
	t.Color.y = ((1-x)*(1-y) * c00.blue() + (1-x)*y*c01.blue() +
						x*(1-y)*c10.blue() + x*y*c11.blue()) / 255;
};

void BumpMap :: Apply(Vector& p, SurfaceData& t) {
	double x = Mod(Offs.x + Scale.x * p.x, Img->width());
	double y = Mod(Offs.y + Scale.y * p.y, Img->height());
	int ix = (int) x;
	int iy = (int) y;
	int jx = ix + 1;
	int jy = iy + 1;
	x -= ix;
	y -= iy;
	if(jx >= Img->width()) jx = 0; //wrap around
	if(jy >= Img->height()) jy = 0;
	//interpolate between corners
	QColor c00 = Img->pixel(ix, iy);
	QColor c01 = Img->pixel(ix, jy);
	QColor c10 = Img->pixel(jx, iy);
	double i00 = (0.229 * c00.red() + 0.587 * c00.green() + 0.114 * c00.blue()) / 255;
	double i01 = (0.229 * c01.red() + 0.587 * c01.green() + 0.114 * c01.blue()) / 255;
	double i10 = (0.229 * c10.red() + 0.587 * c10.green() + 0.114 * c10.blue()) / 255;
	double du = (i10 - i00) * Amount;
	double dv = (i01 - i00) * Amount;
	Vector tu, tv;
	if(object->Mapping != NULL) {
		object->Mapping->FindTangent(p, tu, tv);
	}
	t.n += du * (t.n ^ tv) - dv * (t.n ^ tu);
	t.n = Normalize(t.n);
};
