/*
 * config.h
 *
 *  Created on: 21.02.2009
 *      Author: Лёха
 *
 */

#ifndef CONFIG_H_
#define CONFIG_H_

#include <QThread>

#define _TRACE_DEBUG 			true 		// Режим разработчика
#define _TRACE_TYPE 			1 			// 0 - default, 1 - antialias, 2 - antialias & rate
#define _ANTI_ALIAS_X 			3 			// сдвиг по x (не действует на рендер типа 0)
#define _ANTI_ALIAS_Y 			3 			// сдвиг по y (не действует на рендер типа 0)
#define _ACCURACY 				0.7 		// степень точности (для рендеринга под типом 2)

#define _MULTY_THREAD 			true  		// true - многопоточное приложение (не реализовано для режима 2)
#define _MULTY_THREAD_PRIORITY  QThread::TimeCriticalPriority 		// приоритет потоков
#define _MULTY_THREAD_COUNT		QThread::idealThreadCount()	//число потоков

#define _MAX_LEVEL_RECURSION	100			//число отслеживаемых отражений
#define _THRESHOLD				0.01		//степень чувствительности для вычислений
#define _GEOM_THRESHOLD			0.001		//степень детальности объектов
#define _MAX_LIGHTS 			10			//максимальное число источников света
#define _MAX_SOLIDS 			100			//максимальное число объектов
#define _INFINITY 				30000		//мнимая бесконечность (INFINITY)

//не рекомендуется выключать (актуально для многопоточного рендера)
//можно выключить, если в сцене нет зеркальных поверхностей (даст прирост скорости в 1,5 раза)
#define _MULTY_THREAD_LOCK		false		//блокировка уровня погружения в рекурсию, при многопоточности

#endif /* CONFIG_H_ */
